//
//    Dump shared memory partition status.
//
//
#include "lsmp.hh"
#include <stdlib.h>
#include <iostream>

using namespace std;

//======================================  Main function
int 
main(int argc, const char *argv[]) {

    const char *name = getenv("LIGOSMPART");
    int flg = 0;
    bool syntax = false;
    for (int i=1; i<argc; ++i) {
        if (*argv[i] == '-') {
	    for (const char* p=argv[i]+1; *p; ++p) {
	       if ( *p == 'a')      flg |= 0xff;
	       else if ( *p == 'b') flg |= 0x04;
	       else if ( *p == 'c') flg |= 0x08;
	       else if ( *p == 'h') flg |= 0x01;
	       else if ( *p == 's') flg |= 0x02;
	       else syntax = true;
	    }
	} else {
	    name = argv[i];
	}
    }
    if (!flg) flg = 0xff;

    //----------------------------------  Check that the name was specified
    if (!name) {
        cerr << "sdump: Partition name not specified" << std::endl;
	syntax = true;
    }

    //----------------------------------  Command syntax error
    if (syntax) {
        cerr << "Syntax:" << std::endl;
        cerr << "sdump [-abchs] [<partition-name>]" << std::endl;
	return 1;
    }

    //----------------------------------  Dump the partition.
    LSMP_ACCESS part(name);
    part.dump(flg);
}
